package DataStore;

use strict;
use Safe;
use Data::Dumper;
require Exporter;

use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

@ISA = qw(Exporter);
@EXPORT = ();
@EXPORT_OK = qw(save load);

($VERSION) = '$Revision: 1.0 $' =~ m/Revision:\s*(\S+)/;

sub save {
    my ($file, $data) = @_;

    local $Data::Dumper::Indent   = 0;
    local $Data::Dumper::Purity   = 0;
    local $Data::Dumper::Useqq    = 1;
    local $Data::Dumper::Deepcopy = 0;   
    
    my $d = new Data::Dumper([$data], ["D"]);

    open FILE, ">$file" or return undef;
    flock FILE, 2;
    binmode FILE;
    print FILE $d->Dump();
    close FILE;

    return 1;
}



sub load {
    my ($file) = @_;    

    open FILE, "<$file";
    flock FILE, 2;
    binmode FILE;
    my $string = join '', <FILE>;
    close FILE;
    # To make -T happy
    my ($safe_string) = $string =~ m/^(.*)$/;
    
    my $D = undef;
    my $cpt = new Safe();
    $D = $cpt->reval($safe_string);
    if ( $@ ) {
        die $@;
    }
    if ($D)
    {
      return %{$D};
    }
    else
    {
      return ();
    }
}
