package Dir::Delete;

use strict;
require Exporter;
require DynaLoader;

use vars qw(@ISA @EXPORT $VERSION $OLD_CODE);

$VERSION = '1.0';

@ISA = qw(Exporter DynaLoader);
@EXPORT = qw(delete);

sub new 
{
  my $pkg = shift;
  my $self; { my %hash; $self = bless(\%hash, $pkg); }

  for (my $x = 0; $x <= $#_; $x += 2) 
  {
    defined($_[($x + 1)]) or croak("Dir::Delete->new() called with odd number of option parameters - should be of the form option => value");
    $self->{lc($_[$x])} = $_[($x + 1)];
  }

  $self->{verbose} = 0 if (!defined $self->{verbose});

  return $self;
}

sub delete
{
  my ($self, $dir) = @_;

  $self->{errors} = ();

  $dir =~ s~[\\/]+$~~s;

  my $err_flag = 0;

  if (-e $dir && ! -d $dir)
  {
    unlink("$dir") or push @{$self->{errors}}, "Can't delete $dir : $!";
  }
  else
  {
    _dir_delete($self, $dir);
  }
}

sub _dir_delete
{
  my ($self, $dir) = @_;

  $dir =~ s~[\\/]+$~~s;

  my $err_flag = 0;
  if (! -e $dir)
  {
    push @{$self->{errors}}, "Directory $dir not exists";
  }

  my $err_flag = 0;
  opendir DIR, ($dir) or $err_flag = 1;
  if ($err_flag)
  {
    push @{$self->{errors}}, "Can't open directory: $dir";
    return;
  }
  my @files = grep {$_ ne '.' && $_ ne '..'} readdir DIR;
  close DIR;

  for my $file (@files)
  {
    if (-d "$dir/$file")
    {
      _dir_delete($self, "$dir/$file");
    }
    else
    {
      unlink("$dir/$file") or push @{$self->{errors}}, "Can't delete $dir/$file : $!";
    }
  }

  rmdir($dir) or push @{$self->{error}}, "Can't delete $dir : $!";
}