package mylib;
use CONFIG;
use DataStore qw{load save};

#use vars qw{$ROOT_DIR};

sub adm_main_tmpl
{
	my($cgi, $templ, $st, $info) = @_;

	$templ->param( 
			SNAME => $ENV{'SCRIPT_NAME'}, 
			image_dir => $CONFIG::images_dir,
                     );

	my $template = HTML::Template->new(
                                      filename=>"$CONFIG::tmpl_path/adm_main.tmpl",
                                      die_on_bad_params=>0,
                                      global_vars=>1,
                                      associate=>[$cgi]
                                    );

	$template->param(   
                      BODY => (($st > 0) ? $templ : $templ->output),
                      INFO => $info,
		      image_dir => $CONFIG::images_dir,
                      SNAME => $ENV{'SCRIPT_NAME'},
                  );
	return $template;
}

sub adm_popup_main_tmpl
{
	my($cgi, $templ, $st, $info) = @_;

	$templ->param( 
			SNAME => $ENV{'SCRIPT_NAME'}, 
			image_dir => $CONFIG::images_dir,
                     );

	my $template = HTML::Template->new(
                                      filename=>"$CONFIG::tmpl_path/adm_popup_main.tmpl",
                                      die_on_bad_params=>0,
                                      global_vars=>1,
                                      associate=>[$cgi]
                                    );

	$template->param(   
                      BODY => (($st > 0) ? $templ : $templ->output),
                      INFO => $info,
		      image_dir => $CONFIG::images_dir,
                      SNAME => $ENV{'SCRIPT_NAME'},
                  );
	return $template;
}

sub usr_main_tmpl
{
	my($cgi, $templ, $st, $info) = @_;

	$templ->param( 
			SNAME => $ENV{'SCRIPT_NAME'}, 
			image_dir => $CONFIG::images_dir,
                     );

	my $template = HTML::Template->new(
                                      filename=>"$CONFIG::tmpl_path/usr_main.tmpl",
                                      die_on_bad_params=>0,
                                      global_vars=>1,
                                      associate=>[$cgi]
                                    );

	$template->param(   
                      BODY => (($st > 0) ? $templ : $templ->output),
                      INFO => $info,
                      SNAME => $ENV{'SCRIPT_NAME'},
		      image_dir => $CONFIG::images_dir,
                      ADMIN_MAIL => $CONFIG::admin_mail,
                  );
	return $template;
}

sub usr_main_popup_tmpl
{
	my($cgi, $templ, $st, $info) = @_;

	$templ->param( 
			SNAME => $ENV{'SCRIPT_NAME'}, 
			image_dir => $CONFIG::images_dir,
                     );

	my $template = HTML::Template->new(
                                      filename=>"$CONFIG::tmpl_path/usr_popup_main.tmpl",
                                      die_on_bad_params=>0,
                                      global_vars=>1,
                                      associate=>[$cgi]
                                    );

	$template->param(   
                      BODY => (($st > 0) ? $templ : $templ->output),
                      INFO => $info,
		      image_dir => $CONFIG::images_dir,
                      SNAME => $ENV{'SCRIPT_NAME'},
                  );
	return $template;
}

sub main_tmpl
{
	my($cgi, $templ, $st, $info) = @_;

	$templ->param( 
			SNAME => $ENV{'SCRIPT_NAME'}, 
			image_dir => $CONFIG::images_dir,
                     );

	my $template = HTML::Template->new(
                                      filename=>"$CONFIG::tmpl_path//main.tmpl",
                                      die_on_bad_params=>0,
                                      global_vars=>1,
                                      associate=>[$cgi]
                                    );

	$template->param(   
                      BODY => (($st > 0) ? $templ : $templ->output),
                      INFO => $info,
		      image_dir => $CONFIG::images_dir,
                      SNAME => $ENV{'SCRIPT_NAME'},
                  );
	return $template;
}


sub _date_FromUnixToUSA
{
  my ($unix_date) = @_;
  return sprintf("%02d/%02d/%04d", (localtime($unix_date))[3], (localtime($unix_date))[4] + 1, (localtime($unix_date))[5] + 1900);
}
sub date_FromUnixToUSA
{
  my ($unix_date) = @_;
  my %monthes = (1 => 'Jan', 2 => 'Feb', 3 => 'Mar', 4 => 'Apr', 5 => 'May', 6 => 'Jun', 7 => 'Jul', 8 => 'Aug', 9 => 'Sep', 10 => 'Oct', 11 => 'Nov', 12 => 'Dec');
  my ($day, $month, $year) = ((localtime($unix_date))[3], (localtime($unix_date))[4] + 1, (localtime($unix_date))[5] + 1900);

  return sprintf("%02d, %s %04d", $day, $monthes{$month}, $year);
}

sub time_FromUnixToUSA
{
  my ($unix_date) = @_;
  my %monthes = (1 => 'Jan', 2 => 'Feb', 3 => 'Mar', 4 => 'Apr', 5 => 'May', 6 => 'Jun', 7 => 'Jul', 8 => 'Aug', 9 => 'Sep', 10 => 'Oct', 11 => 'Nov', 12 => 'Dec');
  return sprintf("%02d %s %04d %02d:%02d:%02d", (localtime($unix_date))[3], $monthes{(localtime($unix_date))[4] + 1}, (localtime($unix_date))[5] + 1900, (localtime($unix_date))[2], (localtime($unix_date))[1], (localtime($unix_date))[0]);
}

sub file_size
{
  my ($bite_size, $mode) = @_;

  if ($mode eq '1')
  {
    my $size = '';

    if (int ($bite_size / 1073741824) > 0)
    {
      my $gbites = int ($bite_size / 1073741824);
      $size .= "$gbites Gb ";
      $bite_size = ($bite_size % 1073741824);
    }

    if (int($bite_size / 1048576) > 0)
    {
      my $gbites = int ($bite_size / 1048576);
      $size .= "$gbites Mb ";
      $bite_size = ($bite_size % 1048576);
    }

    if (int($bite_size / 1024) > 0)
    {
      my $gbites = int ($bite_size / 1024);
      $size .= "$gbites Kb ";
      $bite_size = ($bite_size % 1024);
    }

    $size .= "$bite_size b";

    return $size;
  }
  else
  {
    return $bite_size;
  }
}

sub send_mail
{
  my ($template, $data) = @_;

  open FILE, "<$template";
  flock FILE, 2;
  my $text = join '', <FILE>;
  close FILE;

  for my $key (keys %{$data})
  {
    $text =~ s/$key/$data->{$key}/gs;
  }

  open(MAIL, $CONFIG::sendmail);
  print MAIL $text;
  close MAIL;
}

sub encode_url 
{
    my ($toencode) = @_;
    $toencode =~ s/&amp;/&/gi;
    $toencode =~ s/([^a-zA-Z 0-9_\\\-\.])/sprintf("%%%02X",ord($1))/ego;
    $toencode =~ s/ /+/gm;
    return $toencode;
}

sub prepare_view
{
  my ($values) = @_;

  map {s/\&/\&\#38\;/gs} @{$values};
  map {s/</&lt;/gs} @{$values};
  map {s/>/&gt;/gs} @{$values};
  map {s/\"/\&\#34\;/gs} @{$values};
  map {s/\'/\&\#39\;/gs} @{$values};
}

sub prepare_hash_view
{
  my ($hash) = @_;

  for my $key (keys %{$hash})
  {
    my $safe_key = $key;
    $safe_key =~ s/\&/\&\#38\;/gs;
    $safe_key =~ s/</&lt;/gs;
    $safe_key =~ s/>/&gt;/gs;
    $safe_key =~ s/\"/\&\#34\;/gs;
    $safe_key =~ s/\'/\&\#39\;/gs;

    if ($safe_key ne $key)
    {
      $hash->{$safe_key} = $hash->{$key};
      delete $hash->{$key};
      $key = $safe_key;
    }

    if (ref $hash->{$key} eq 'HASH')
    {
      mylib::prepare_hash_view($hash->{$key});
    }
    elsif (ref $hash->{$key} eq 'ARRAY')
    {
      mylib::prepare_array_view($hash->{$key});
    }
    else
    {
      $hash->{$key} =~ s/\&/\&\#38\;/gs;
      $hash->{$key} =~ s/</&lt;/gs;
      $hash->{$key} =~ s/>/&gt;/gs;
      $hash->{$key} =~ s/\"/\&\#34\;/gs;
      $hash->{$key} =~ s/\'/\&\#39\;/gs;
    }
  }                  
}                    

sub prepare_array_view
{
  my ($array) = @_;

  for (my $key = 0; $key < @{$array}; $key++)
  {
    if (ref $array->[$key] eq 'HASH')
    {
      mylib::prepare_hash_view(\%{$array->[$key]});
      next
    }
    if (ref $array->[$key] eq 'ARRAY')
    {
      mylib::prepare_array_view(\@{$array->[$key]});
      next;
    }

    $array->[$key] =~ s/\&/\&\#38\;/gs;
    $array->[$key] =~ s/</&lt;/gs;
    $array->[$key] =~ s/>/&gt;/gs;
    $array->[$key] =~ s/\"/\&\#34\;/gs;
    $array->[$key] =~ s/\'/\&\#39\;/gs;
  }                  
}                    

sub prepare_cgi_view
{
  my ($cgi) = @_;

  for my $key (keys %{$cgi})
  {
    next if $key =~ /^\./;
    map {s/\&/\&\#38\;/gs} @{$cgi->{$key}};
    map {s/</&lt;/gs} @{$cgi->{$key}};
    map {s/>/&gt;/gs} @{$cgi->{$key}};
    map {s/\"/\&\#34\;/gs} @{$cgi->{$key}};
    map {s/\'/\&\#39\;/gs} @{$cgi->{$key}};
  }
}

sub get_files
{
  my ($dir, $files) = @_;
  my @files = @{$files};

  my @out = ();
  for my $file_name (@files)
  {
    if ($file_name =~ /[\\\/]/)
    {
      $file_name = (split /[\\\/]/, $file_name)[-1];
    }
    next if (!$file_name);
    next if (! -e "$dir/$file_name");

    push @out, $file_name;
  }

  return @out;
}

sub gen_pages
{
  my ($count_pages, $current_page) = @_;

  my @pages = ();
  for my $page (1..$count_pages)
  {
    push @pages, { 
                   PAGE => $page, 
                   CURRENT => ($page == $current_page) ? 1 : 0,
                 };
  }
  return @pages;
}

sub gen_pass
{
  my ($length) = @_;

  my @chars = (0..9, 'A'..'Z', 'a'..'z');
  my $pass = '';
  for (0..$length)
  {
    $pass .= $chars[int rand @chars]
  }
  return $pass;
}

sub get_date_arrays
{
  my ($year, $month, $day, $years_after, $years_before) = @_;

  $year ||= (localtime())[5] + 1900;
  $year_from = ($year != 0) ? ($year - $years_before) : (localtime())[5] + 1900 - $years_before;
  $year_to = ($year != 0) ? ($year + $years_after) : (localtime())[5] + 1900 + $years_after;
  $month ||= (localtime())[4] + 1;
  $day ||= (localtime())[3];

  my @day = ();
  for (1..31)
  {
    push @day, {NAME => $_, VALUE => $_, SELECTED => ($_ == $day) ? 1 : 0 };
  }

  my @month = ();
  for (1..12)
  {
    push @month, {NAME => $_, VALUE => $_, SELECTED => ($_ == $month) ? 1 : 0 };
  }

  my @year = ();
  for ($year_from..$year_to)
  {
    push @year, {NAME => $_, VALUE => $_, SELECTED => ($_ == $year) ? 1 : 0 };
  }

  return \@year, \@month, \@day;
}

sub numcmp
{
  my ($a, $b) = @_;
  if ($a < $b)
  {
    return -1;
  }
  elsif ($a == $b)
  {
    return 0;
  }
  else
  {
    return 1;
  }
}

sub close_and_reload
{
  my ($location) = @_;

  my $location_str = '.reload()';
  if ($location)
  {
    $location_str = " = '$location'";
  }

  return <<HTML;
Content-type: text/html

<html>
<head>
<title>Window Closing</title>
</head>
<script language="javascript">
try{
opener.location$location_str;
}catch(all){};
window.close();
</script>
</html>
HTML
}

sub synchronize_paths
{
  my ($current_path, $new_path) = @_;


  if ($new_path =~ m~^/~)
  {
    return $new_path;
  }

  if ($current_path !~ m~/$~) { $current_path .= '/' };
  if ($new_path !~ m~/$~) { $new_path .= '/' };

  while ($path =~ m~[\\/]\.[\\/]~)
  {
    $new_path =~ s~([\\/])\.[\\/]~$1~gs;
  }


  my $path = "$current_path$new_path";

  while ($path =~ m~\.\./~)
  {
    $path =~ s~/[^/]+/\.\./~/~;
  }

  $path =~ s~([\\/])+~$1~gs;

  if ($path !~ m~/$~) { $path .= '/' };
  return $path;
}


sub rename_file
{
  my ($from, $to, $overwrite) = @_;

  my ($from_dir, $copy_file) = $from =~ m~^(.*[\\/])?([^/]+)~;
  my ($to_dir, $copy_file) = $to =~ m~^(.*[\\/])?([^/]+)~;

  use Dir::Move;
  my $mv = Dir::Move->new(overwrite => $overwrite);
  $mv->move($from, $to);

  my @error = map { $_ =~ s~$from_dir[\\/]?~~g; $_ =~ s~$to_dir[\\/]?~~g; {ERROR => $_}; } @{$mv->{errors}};

  return @error;
}

sub copy_file
{
  my ($from, $to, $overwrite) = @_;

  my ($from_dir, $copy_file) = $from =~ m~^(.*[\\/])?([^/]+)~;
  my ($to_dir, $copy_file) = $to =~ m~^(.*[\\/])?([^/]+)~;

  use Dir::Copy;
  my $cp = Dir::Copy->new(overwrite => $overwrite);
  $cp->copy($from, $to);

  my @error = map { $_ =~ s~$from_dir[\\/]?~~g; $_ =~ s~$to_dir[\\/]?~~g; {ERROR => $_}; } @{$cp->{errors}};

  return @error;
}


sub archive_file
{
  my ($from_dir, $to_file, $files) = @_;

  my $cur_dir = `pwd`;
  chdir($from_dir);
  my $result = `$CONFIG::tar -zcf "$to_file" $files 2>&1`;
  chdir($cur_dir);

  my @strs = split /\ntar[^\:]*:/, "\n$result";

  my @error = ();
  for my $str (@strs)
  {
    next if $str =~ /^\s*$/;
    $str =~ s/$from_dir\/?//gsi;
    push @error, { FILE => '', ERROR => $str };
  }

  return @error;
}

sub unarchive_file
{
  my ($from_dir, $file, $overwrite) = @_;

  my $keys = '';
  if ($overwrite)
  {
    $keys = 'zxf';
  }
  else
  {
    $keys = 'zxkf';
  }

  my $result = `$CONFIG::tar -$keys "$from_dir/$file" -C "$from_dir" 2>&1`;
  my @strs = split /\ntar[^\:]*:|\ngzip[^\:]*:[^:]+:/, "\n$result";

  my @error = ();
  for my $str (@strs)
  {
    next if $str =~ /^\s*$/;
    $str =~ s/$from_dir\/?//gsi;
    push @error, { FILE => '', ERROR => $str };
  }

  return @error;
}

sub test_archive
{
  my ($file) = @_;

  my $result = `$CONFIG::tar -ztf "$file" 2>&1`;

  if ($result =~ /tar: child returned status (\d+)/)
  {
    return 0;
  }
  else
  {
    return (split /\n/, $result);
  }

  return 0;
}

sub write_file
{
  my ($file, $content) = @_;

  $content =~ s/\r//gs;

  open FILE, ">$file" or return { FILE => $file, ERROR => $!};
  flock FILE, 2;
  print FILE $content;
  close FILE or return { FILE => $file, ERROR => $!};

  return ();
}

sub get_doc
{
  use IO::Socket;
  my ($url) = @_;

  my ($username, $password, $host, $path) = (parse_url($url))[1,2,3,5];

  my $soc = IO::Socket::INET->new(
				  PeerAddr=>$host,
				  PeerPort=>'http',
				  Proto=>'tcp',
				  Type=>SOCK_STREAM
                                 );
  if (!$soc)
  {
    return ('', "Could not connect to $host");
  }

  my $auth = "Authorization: Basic ".encode_base64($username.':'.$password)."\n" if ($username ne '');

  my $get="GET /$path HTTP/1.0\nAccept: */*\nAccept-Language: en-us\n".$auth."User-Agent: EasyFileManager 2.0\nHost: $host\n\n";
  print $soc $get;

  my @doc = <$soc>;
  close $soc;
  my $doc = join '', @doc;
  my($header, $response) = split /\r*\n\r*\n/, $doc, 2;

  if ($header !~ /HTTP\/\d+\.\d+\s*(200[^\n]*)/i)
  {
    my ($error) = $header =~ /HTTP\/\d+\.\d+\s*([^\n]*)/i;
    return ('', "Server Response Error: $error");
  }
  else
  {
    return $response;
  }
}

sub get_ftp_doc
{
  my ($host, $login, $password, $remote_file, $local_file) = @_;
  use Net::FTP;

  my $ftp = Net::FTP->new($host, Passive => 1) or return ('', "Could not connect to $host");
  $ftp->login($login, $password) or return ('', "Could not log in to $host");
  $ftp->get($remote_file, $local_file) or return ('', "Could not get $remote_file: $!");
  $ftp->quit();
}

sub create_folder
{
  my ($folder) = @_;

  mkdir ($folder, 0755) or return { FILE => $folder, ERROR => $!};

  return ();
}

sub delete_file
{
  my ($file, $erase) = @_;

  my @error = ();
  if ($erase)
  {
    return "Can't delete all" if ($file eq '/');

    my ($current_dir, $del_file) = $file =~ m~^(.*[\\/])?([^/]+)~;

    use Dir::Delete;
    my $del = Dir::Delete->new();
    $del->delete($file);

    @error = map { $_ =~ s~$current_dir[\\/]?~~g; {ERROR => $_}; } @{$del->{errors}};
  }
  else
  {
    my ($current_dir, $del_file) = $file =~ m~^(.*[\\/])?([^/]+)~;
    if ($del_file eq 'init.dat')
    {
      return ({ FILE => $del_file, ERROR => "Could not replace init.dat"});
    }

    my $new_del_file = $del_file;
    my $i = 1;

    while (-e "$CONFIG::recycle_dir/$new_del_file" && ($i < 20))
    {
      $new_del_file = "$del_file\[$i\]";
      $i++;
    }

    my %data = load("$CONFIG::recycle_dir/init.dat");
    $data{$new_del_file}->{SOURCE_FILE} = $file;
    $data{$new_del_file}->{DATE} = time;
    save("$CONFIG::recycle_dir/init.dat", \%data);

    use Dir::Move;
    my $mv = Dir::Move->new(overwrite => 0);
    $mv->move($file, "$CONFIG::recycle_dir/$new_del_file");

    @error = map { $_ =~ s~$CONFIG::recycle_dir~~g; $_ =~ s~$current_dir[\\/]?~~g; {ERROR => $_}; } @{$mv->{errors}};
  }

  return @error;
}


sub dir_size
{
  my ($dir) = @_;

  my $size = 0;

  if ($dir !~ /[\\\/]$/)
  {
    $dir .= '/';
  }

  opendir DIR, $dir or print "error: $!\n";
  my @files = grep {!/^\./} readdir DIR;
  closedir DIR;

  for my $file (@files)
  {
    if (-d "$dir$file")
    {
      $size += -s("$dir$file");
      $size += dir_size("$dir$file/");
    }
    else
    {
      next if ($file eq 'init.dat');
      $size += -s("$dir$file");
    }
  }
  return $size;
}

sub parse_url
{
    my($u) = @_;
    return unless $u;

    # This parsing code is based on
    #   draft-ietf-uri-relative-url-06.txt Section 2.4

    # 2.4.1
    my $frag = uri_unescape($1) if $u =~ s/#(.*)$//;
    # 2.4.2
    my $scheme = lc($1) if $u =~ s/^\s*([\w\+\.\-]+)://;
    # 2.4.3
    my $netloc = $1 if $u =~ s!^//([^/]*)!!;
    my $nl = $netloc;
    my $user = '';
    my $pasword = '';
    my $host = '';
    my $port = '';

    if ($nl =~ s/^([^:@]*):?(.*?)@//){
	$user     = uri_unescape($1);
	$password = uri_unescape($2) if $2 ne '';
    }
    if ($nl =~ /^([^:]*):?(\d*)$/){
	$port = $2;
	# Since this happes so frequently, we inline this call:
	#    my $host = uri_unescape($1);
	$host = $1;
	$host =~ s/%([\dA-Fa-f]{2})/chr(hex($1))/eg;
    }

    # 2.4.4
    my $query = $1 if $u =~ s/\?(.*)//;
    # 2.4.5
    my $params = $1 if $u =~ s/;(.*)//;

    my $path = $u;
    $path = '/' if ($path eq '');

    return ($scheme, $user, $password, $host, $port, $path, $params, $query, $frag);
}

sub uri_escape
{
    my($text) = @_;
    return undef unless defined $text;

    my %escapes = ();
    for (0..255) {
        $escapes{chr($_)} = sprintf("%%%02X", $_);
    }
    # Default unsafe characters. (RFC1738 section 2.2)
    $text =~ s/([\x00-\x20\"#%;<>?{}|\\^~`\[\]\x7F-\xFF])/$escapes{$1}/g;

    return $text;
}

sub uri_unescape
{
    # Note from RFC1630:  "Sequences which start with a percent sign
    # but are not followed by two hexadecimal characters are reserved
    # for future extension"
    my @copy = @_;
    for (@copy) { s/%([\dA-Fa-f]{2})/chr(hex($1))/eg; }
    wantarray ? @copy : $copy[0];
}

sub log_action
{
  my ($message) = @_;

  my $time = time;
  my $ip   = $ENV{REMOTE_ADDR};

  open FILE, ">>$CONFIG::actions_log";
  flock FILE, 2;
  print FILE "$time\t$ip\t$message\n";
  close FILE;
}

sub create_htaccess
{
  my ($dir) = @_;

  my $access_file = "$dir/.htaccess";

  if (!-e $access_file)
  {
    open FILE, ">$access_file" or return "Can't create $access_file .htaccess file: $!";
    close FILE;
  }

  open FILE, "+<$access_file" or return "Can't write to .htaccess file: $!";
  flock FILE, 2;
  my @access_data = <FILE>;

  truncate FILE, 0;
  seek FILE, 0, 0;

  my $AuthUserFile = 0;
  my $AuthGroupFile = 0;
  my $AuthType = 0;
  my $AuthName = 0;
  my $Require = 0;

  for (@access_data)
  {
    if (/AuthUserFile/i)
    {
      $AuthUserFile = 1;
      print FILE "AuthUserFile $dir/.htpasswd\n";
    }
    elsif (/AuthGroupFile/i)
    {
      $AuthGroupFile = 1;
      print FILE "AuthGroupFile /dev/null\n";
    }
    elsif (/AuthType/i)
    {
      $AuthType = 1;
      print FILE "AuthType Basic\n";
    }
    elsif (/AuthName/i)
    {
      $AuthName = 1;
      print FILE "AuthName \"Protected Area\"\n";
    }
    elsif (/Require/i)
    {
      $Require = 1;
      print FILE "Require valid-user\n";
    }
    else
    {
      print FILE;
    }
  }

  if (!$AuthUserFile)
  {
    print FILE "AuthUserFile $dir/.htpasswd\n";
  }
  if (!$AuthGroupFile)
  {
    print FILE "AuthGroupFile /dev/null\n";
  }
  if (!$AuthType)
  {
    print FILE "AuthType Basic\n";
  }
  if (!$AuthName)
  {
    print FILE "AuthName \"Protected Area\"\n";
  }
  if (!$Require)
  {
    print FILE "Require valid-user\n";
  }
  close FILE;

  return undef;
}

sub remove_htaccess
{
  my ($dir) = @_;

  my $access_file = "$dir/.htaccess";

  if (!-e $access_file)
  {
    return 1;
  }

  open FILE, "+<$access_file" or return "Can't write to .htaccess file: $!";
  flock FILE, 2;
  my @access_data = <FILE>;

  truncate FILE, 0;
  seek FILE, 0, 0;

  for (@access_data)
  {
    if (/AuthUserFile/i)
    {
      next;
    }
    elsif (/AuthGroupFile/i)
    {
      next;
    }
    elsif (/AuthType/i)
    {
      next;
    }
    elsif (/AuthName/i)
    {
      next;
    }
    elsif (/Require/i)
    {
      next;
    }
    else
    {
      print FILE;
    }
  }
  close FILE;

  return undef;
}

sub del_htaccess_user
{
  my ($dir, $del_users) = @_;

  if (!-e "$dir/.htpasswd")
  {
    open FILE, ">$dir/.htpasswd" or return "Can't create .htpasswd file: $!";
    close FILE;
  }

  my $found = 0;
  open FILE, "+<$dir/.htpasswd" or return "Can't write to .htpasswd file: $!";
  flock FILE, 2;
  my @users = <FILE>;

  truncate FILE, 0;
  seek FILE, 0, 0;

  for my $line (@users)
  {
    my $user = (split /:/, $line)[0];
    if ($user eq $del_users)
    {
      $found = 1;
    }
    else
    {
      print FILE $line;
    }
  }
  close FILE;

  if (!$found)
  {
    return "User $del_user not found";
  }
}

sub add_htaccess_user
{
  my ($dir, $user, $password) = @_;

  if (!-e "$dir/.htpasswd")
  {
    open FILE, ">$dir/.htpasswd" or return "Can't create .htpasswd file: $!";
    close FILE;
  }

  if ($CONFIG::crypt_method == 2)
  {
    $password = apache_unix_crypt($password);
  }
  elsif ($CONFIG::crypt_method == 3)
  {
    $password = unix_md5_crypt($password);
  }
  elsif ($CONFIG::crypt_method == 4)
  {
    $password = $password;
  }
  else
  {
    my $salt = '';
    for (0..2) { $salt .= ('A'..'Z', 0..9)[int rand 34]; }
    $salt .= '........';
    $password = apache_md5_crypt($password, $salt);
  }

  open FILE, ">>$dir/.htpasswd" or return "Can't write to .htpasswd file: $!";
  flock FILE, 2;
  print FILE "$user:$password\n";
  close FILE;

  return undef;
}

$Magic = '$1$';

###############################################################################
# APACHE_UNIX_CRYPT
###############################################################################
sub apache_unix_crypt {
    my ($passwd,$salt)=@_;
    if ($salt) {$salt = substr ($salt, 0, 2)}
    else {$salt = substr ($0, 0, 2)}
    return crypt ($passwd, $salt);
}

###############################################################################
# APACHE_MD5_CRYPT
###############################################################################
sub apache_md5_crypt {
    local $Magic = '$apr1$';
    unix_md5_crypt(@_);
}

###############################################################################
# UNIX_MD5_CRYPT
###############################################################################
sub unix_md5_crypt {
    my($pw, $salt) = @_;
    my $passwd;

    $salt =~ s/^\Q$Magic//;
    $salt =~ s/^(.*)\$.*$/$1/;
    $salt = substr($salt, 0, 8);

    $ctx = new Digest::MD5;
    $ctx->add($pw);
    $ctx->add($Magic);
    $ctx->add($salt);

    my ($final) = new Digest::MD5;
    $final->add($pw);
    $final->add($salt);
    $final->add($pw);
    $final = $final->digest;

    for ($pl = length($pw); $pl > 0; $pl -= 16) {
    $ctx->add(substr($final, 0, $pl > 16 ? 16 : $pl));
    }

    for ($i = length($pw); $i; $i >>= 1) {
    if ($i & 1) { $ctx->add(pack("C", 0)); }
    else { $ctx->add(substr($pw, 0, 1)); }
    }

    $final = $ctx->digest;

    for ($i = 0; $i < 1000; $i++) {
    $ctx1 = new Digest::MD5;
    if ($i & 1) { $ctx1->add($pw); }
    else { $ctx1->add(substr($final, 0, 16)); }
    if ($i % 3) { $ctx1->add($salt); }
    if ($i % 7) { $ctx1->add($pw); }
    if ($i & 1) { $ctx1->add(substr($final, 0, 16)); }
    else { $ctx1->add($pw); }
    $final = $ctx1->digest;
    }
    $passwd = '';
    $passwd .= to64(int(unpack("C", (substr($final, 0, 1))) << 16)
            | int(unpack("C", (substr($final, 6, 1))) << 8)
            | int(unpack("C", (substr($final, 12, 1)))), 4);
    $passwd .= to64(int(unpack("C", (substr($final, 1, 1))) << 16)
            | int(unpack("C", (substr($final, 7, 1))) << 8)
            | int(unpack("C", (substr($final, 13, 1)))), 4);
    $passwd .= to64(int(unpack("C", (substr($final, 2, 1))) << 16)
            | int(unpack("C", (substr($final, 8, 1))) << 8)
            | int(unpack("C", (substr($final, 14, 1)))), 4);
    $passwd .= to64(int(unpack("C", (substr($final, 3, 1))) << 16)
            | int(unpack("C", (substr($final, 9, 1))) << 8)
            | int(unpack("C", (substr($final, 15, 1)))), 4);
    $passwd .= to64(int(unpack("C", (substr($final, 4, 1))) << 16)
            | int(unpack("C", (substr($final, 10, 1))) << 8)
            | int(unpack("C", (substr($final, 5, 1)))), 4);
    $passwd .= to64(int(unpack("C", substr($final, 11, 1))), 2);

    $final = '';
    $Magic . $salt . '$' . $passwd;
}

###############################################################################
# TO_BASE64
###############################################################################
sub to64 {
    my ($v, $n) = @_;
    my $itoa64 = "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
    my $ret = '';
    while (--$n >= 0) {
    $ret .= substr($itoa64, $v & 0x3f, 1);
    $v >>= 6;
    }
    $ret;
}


1;
